Index: java/main/src/main/java/com/framsticks/communication/ResponseCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ResponseCallback.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/ResponseCallback.java	(revision 84)
@@ -1,7 +1,3 @@
 package com.framsticks.communication;
-
-import com.framsticks.params.SourceInterface;
-
-import java.util.List;
 
 /**
Index: java/main/src/main/java/com/framsticks/communication/ServerConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 84)
@@ -3,12 +3,8 @@
 import com.framsticks.communication.queries.*;
 import com.framsticks.params.SourceInterface;
-import com.framsticks.util.Pair;
-import com.framsticks.util.Strings;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
 import org.apache.log4j.Logger;
 
-import java.io.BufferedReader;
-import java.io.IOException;
-import java.io.InputStreamReader;
-import java.io.PrintWriter;
 import java.net.Socket;
 
@@ -18,114 +14,114 @@
 public class ServerConnection extends Connection {
 
-    private final static Logger LOGGER = Logger.getLogger(ServerConnection.class);
+	private final static Logger log = Logger.getLogger(ServerConnection.class);
 
-    RequestHandler requestHandler;
+	RequestHandler requestHandler;
 
-    public ServerConnection(Socket socket, RequestHandler requestHandler) {
-        this.socket = socket;
-        this.requestHandler = requestHandler;
-        connected = true;
+	public ServerConnection(Socket socket, RequestHandler requestHandler) {
+		this.socket = socket;
+		this.requestHandler = requestHandler;
+		connected = true;
 
-    }
+	}
 
-    public void start() {
+	public void start() {
 
 
-        runThreads();
-    }
+		runThreads();
+	}
 
-    @Override
-    public String toString() {
-        return socket.getInetAddress().getHostAddress();
-    }
+	@Override
+	public String toString() {
+		return socket.getInetAddress().getHostAddress();
+	}
 
-    @Override
-    protected void receiverThreadRoutine() throws Exception {
-        while (connected) {
-            processNextRequest();
-        }
-    }
+	@Override
+	protected void receiverThreadRoutine() throws Exception {
+		while (connected) {
+			processNextRequest();
+		}
+	}
 
-    protected void handleRequest(Request request, ResponseCallback responseCallback) {
-        if (request instanceof ApplicationRequest) {
-            requestHandler.handle((ApplicationRequest)request, responseCallback);
-            return;
-        }
-        if (request instanceof ProtocolRequest) {
-            if (request instanceof VersionRequest) {
-                responseCallback.process(new Response(true, null, null));
-                return;
-            }
-            if (request instanceof UseRequest) {
-                String feature = ((UseRequest)request).getFeature();
-                if (feature.equals("request_id")) {
-                    requestIdEnabled = true;
-                    responseCallback.process(new Response(true, null, null));
-                    return;
-                }
-                responseCallback.process(new Response(false, "\"unknown feature: " + feature + "\"", null));
-                return;
-            }
+	protected void handleRequest(Request request, ResponseCallback responseCallback) {
+		if (request instanceof ApplicationRequest) {
+			requestHandler.handle((ApplicationRequest)request, responseCallback);
+			return;
+		}
+		if (request instanceof ProtocolRequest) {
+			if (request instanceof VersionRequest) {
+				responseCallback.process(new Response(true, null, null));
+				return;
+			}
+			if (request instanceof UseRequest) {
+				String feature = ((UseRequest)request).getFeature();
+				if (feature.equals("request_id")) {
+					requestIdEnabled = true;
+					responseCallback.process(new Response(true, null, null));
+					return;
+				}
+				responseCallback.process(new Response(false, "\"unknown feature: " + feature + "\"", null));
+				return;
+			}
 
-        }
-        LOGGER.error("unhandled request: " + request);
-        responseCallback.process(new Response(false, "unhandled", null));
-    }
+		}
+		log.error("unhandled request: " + request);
+		responseCallback.process(new Response(false, "unhandled", null));
+	}
 
-    protected final void respond(final Response response, final Integer id) {
-        senderThread.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                String outId = id != null ? " " + id : "";
-                if (response.getFiles() != null) {
-                    for (File f : response.getFiles()) {
-                        output.print("file" + outId/* + " " + f.getPath()*/ + "\n");
-                        SourceInterface content = f.getContent();
-                        String line;
-                        while ((line = content.readLine()) != null) {
-                            output.print(line);
-                            output.print('\n');
-                        }
-                        output.print("eof\n");
-                    }
-                }
-                output.print(response.getOk() ? "ok" : "error");
-                output.print(outId);
-                if (Strings.notEmpty(response.getComment())) {
-                    output.print(' ');
-                    output.print(response.getComment());
-                }
-                output.print('\n');
-                output.flush();
-            }
-        });
+	protected final void respond(final Response response, final Integer id) {
+		senderThread.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				String outId = id != null ? " " + id : "";
+				if (response.getFiles() != null) {
+					for (File f : response.getFiles()) {
+						output.print("file" + outId/* + " " + f.getPath()*/ + "\n");
+						SourceInterface content = f.getContent();
+						String line;
+						while ((line = content.readLine()) != null) {
+							output.print(line);
+							output.print('\n');
+						}
+						output.print("eof\n");
+					}
+				}
+				output.print(response.getOk() ? "ok" : "error");
+				output.print(outId);
+				if (Strings.notEmpty(response.getComment())) {
+					output.print(' ');
+					output.print(response.getComment());
+				}
+				output.print('\n');
+				output.flush();
+			}
+		});
 
-    }
+	}
 
-    protected void processNextRequest() throws Exception {
-        String line = getLine();
-        Pair<String, String> command = Strings.splitIntoPair(line, ' ', "\n");
-        final Pair<Integer, String> rest = parseRest(command.second);
-        if (rest == null) {
-            respond(new Response(false, "\"invalid input\"", null), null);
-            return;
-        }
+	protected void processNextRequest() throws Exception {
+		String line = getLine();
+		Pair<String, String> command = Strings.splitIntoPair(line, ' ', "\n");
+		final Pair<Integer, String> rest = parseRest(command.second);
+		if (rest == null) {
+			respond(new Response(false, "\"invalid input\"", null), null);
+			return;
+		}
 
-        final Request request = Request.createRequestByTypeString(command.first);
-        if (request == null) {
-            respond(new Response(false, "\"invalid input\"", null), null);
-            return;
-        }
-        request.parseRest(rest.second);
-        if (LOGGER.isTraceEnabled()) {
-            LOGGER.trace("read request: " + request);
-        }
+		final Request request = Request.createRequestByTypeString(command.first);
+		if (request == null) {
+			respond(new Response(false, "\"invalid input\"", null), null);
+			return;
+		}
+		request.parseRest(rest.second);
+		if (log.isTraceEnabled()) {
+			log.trace("read request: " + request);
+		}
 
-        handleRequest(request, new ResponseCallback() {
-            @Override
-            public void process(Response response) {
-                respond(response, rest.first);
-            }
-        });
-    }
+		handleRequest(request, new ResponseCallback() {
+			@Override
+			public void process(Response response) {
+				respond(response, rest.first);
+			}
+		});
+	}
 }
Index: java/main/src/main/java/com/framsticks/communication/Subscription.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 84)
@@ -2,6 +2,6 @@
 
 import com.framsticks.communication.queries.RegistrationRequest;
-import com.framsticks.util.AtOnceDispatcher;
-import com.framsticks.util.Dispatcher;
+import com.framsticks.util.dispatching.AtOnceDispatcher;
+import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.StateFunctor;
 import org.apache.log4j.Logger;
@@ -13,5 +13,5 @@
 public class Subscription {
 
-    private final static Logger LOGGER = Logger.getLogger(Subscription.class);
+    private final static Logger log = Logger.getLogger(Subscription.class);
 
     private final ClientConnection connection;
@@ -51,10 +51,10 @@
             public void process(Response response) {
                 if (!response.getOk()) {
-                    LOGGER.error("failed to unsunscribe " + this + ": " + response.getComment());
+                    log.error("failed to unsunscribe " + this + ": " + response.getComment());
                     stateFunctor.call(new Exception(response.getComment()));
                     return;
                 }
                 assert response.hasFiles();
-                LOGGER.debug("unsunscribed " + this);
+                log.debug("unsunscribed " + this);
                 stateFunctor.call(null);
             }
Index: java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 84)
@@ -2,4 +2,5 @@
 
 import com.framsticks.communication.Request;
+import com.framsticks.util.lang.Delimeted;
 
 import java.util.Collection;
@@ -10,51 +11,44 @@
 public abstract class ApplicationRequest extends Request {
 
-    protected String path;
-    protected String fields;
+	protected String path;
+	protected String fields;
 
-    public ApplicationRequest setPath(String path) {
-        assert path != null;
-        this.path = path;
-        return this;
-    }
+	public ApplicationRequest setPath(String path) {
+		assert path != null;
+		this.path = path;
+		return this;
+	}
 
-    public ApplicationRequest setField(String field) {
-        this.fields = field;
-        return this;
-    }
+	public ApplicationRequest setField(String field) {
+		this.fields = field;
+		return this;
+	}
 
-    public ApplicationRequest setFields(Collection<String> fields) {
-        StringBuilder fieldString = new StringBuilder();
-        boolean notFirst = false;
-        for (String field : fields) {
-            if (notFirst) {
-                fieldString.append(",");
-
-            } else {
-                notFirst = true;
-            }
-            fieldString.append(field);
-        }
-        return setField(fieldString.toString());
-    }
+	public ApplicationRequest setFields(Collection<String> fields) {
+		Delimeted d = new Delimeted(",", "");
+		for (String f : fields) {
+			d.append(f);
+		}
+		return setField(d.build());
+	}
 
 
-    public String getPath() {
-        return path;
-    }
+	public String getPath() {
+		return path;
+	}
 
-    @Override
-    protected StringBuilder construct(StringBuilder buffer) {
-        buffer.append(' ').append(path);
-        if (fields != null) {
-            buffer.append(' ').append(fields);
-        }
-        return buffer;
-    }
+	@Override
+	protected StringBuilder construct(StringBuilder buffer) {
+		buffer.append(' ').append(path);
+		if (fields != null) {
+			buffer.append(' ').append(fields);
+		}
+		return buffer;
+	}
 
-    @Override
-    public void parseRest(String rest) {
-        path = rest;
-    }
+	@Override
+	public void parseRest(String rest) {
+		path = rest;
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java	(revision 84)
@@ -9,7 +9,7 @@
  */
 public class CallRequest extends ApplicationRequest {
+
 	protected String arguments;
 	protected String method;
-
 
 	public CallRequest setArguments(String arguments) {
@@ -21,7 +21,6 @@
 		StringBuilder buffer = new StringBuilder();
 		for (String a : arguments) {
-			String arg = a.trim();
 			buffer.append(" ");
-			Request.quoteValue(buffer, arg);
+			Request.quoteValue(buffer, a.trim());
 		}
 		return this.setArguments(buffer.toString());
@@ -42,5 +41,5 @@
 			buffer.append(arguments);
 		}
-        return buffer;
+		return buffer;
 	}
 
Index: java/main/src/main/java/com/framsticks/communication/queries/GetRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/GetRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/GetRequest.java	(revision 84)
@@ -1,5 +1,3 @@
 package com.framsticks.communication.queries;
-
-import com.framsticks.communication.Request;
 
 /**
Index: java/main/src/main/java/com/framsticks/communication/queries/InfoRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/InfoRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/InfoRequest.java	(revision 84)
@@ -1,5 +1,3 @@
 package com.framsticks.communication.queries;
-
-import com.framsticks.communication.Request;
 
 /**
Index: java/main/src/main/java/com/framsticks/communication/queries/RegistrationRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/RegistrationRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/RegistrationRequest.java	(revision 84)
@@ -1,5 +1,3 @@
 package com.framsticks.communication.queries;
-
-import com.framsticks.communication.Request;
 
 /**
@@ -17,11 +15,11 @@
 	}
 
-    @Override
+	@Override
 	protected StringBuilder construct(StringBuilder buffer) {
-        super.construct(buffer);
+		super.construct(buffer);
 		if (!register) {
 			buffer.append(" remove");
 		}
-        return buffer;
+		return buffer;
 	}
 
Index: java/main/src/main/java/com/framsticks/communication/queries/SetRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/SetRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/SetRequest.java	(revision 84)
@@ -1,5 +1,3 @@
 package com.framsticks.communication.queries;
-
-import com.framsticks.communication.Request;
 
 /**
@@ -23,5 +21,5 @@
 			buffer.append(" \"").append(value).append("\"");
 		}
-        return buffer;
+		return buffer;
 	}
 	@Override
Index: java/main/src/main/java/com/framsticks/communication/queries/UseRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/UseRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/UseRequest.java	(revision 84)
@@ -1,5 +1,3 @@
 package com.framsticks.communication.queries;
-
-import com.framsticks.communication.Request;
 
 /**
@@ -14,21 +12,21 @@
 	}
 
-    @Override
+	@Override
 	public String getCommand() {
 		return "use";
 	}
 
-    @Override
+	@Override
 	protected StringBuilder construct(StringBuilder buffer) {
 		return buffer.append(' ').append(feature);
 	}
 
-    @Override
-    public void parseRest(String rest) {
-        feature = rest;
-    }
+	@Override
+	public void parseRest(String rest) {
+		feature = rest;
+	}
 
-    public final String getFeature() {
-        return feature;
-    }
+	public final String getFeature() {
+		return feature;
+	}
 }
Index: java/main/src/main/java/com/framsticks/communication/queries/VersionRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/VersionRequest.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/queries/VersionRequest.java	(revision 84)
@@ -1,7 +1,5 @@
 package com.framsticks.communication.queries;
 
-import com.framsticks.communication.Request;
-import com.framsticks.util.Numbers;
-import com.sun.j3d.loaders.ParsingErrorException;
+import com.framsticks.util.lang.Numbers;
 
 /**
@@ -19,16 +17,16 @@
 	}
 
-    @Override
+	@Override
 	public String getCommand() {
 		return "version";
 	}
 
-    @Override
-    public void parseRest(String rest) {
-        version = Numbers.parse(rest, Integer.class);
-    }
+	@Override
+	public void parseRest(String rest) {
+		version = Numbers.parse(rest, Integer.class);
+	}
 
-    @Override
-    protected StringBuilder construct(StringBuilder buffer) {
+	@Override
+	protected StringBuilder construct(StringBuilder buffer) {
 		return buffer.append(' ').append(version);
 	}
Index: java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 84)
@@ -3,5 +3,4 @@
 import com.framsticks.communication.StateCallback;
 import org.apache.log4j.Logger;
-import org.apache.log4j.Priority;
 
 /**
Index: java/main/src/main/java/com/framsticks/core/Entity.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Entity.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/Entity.java	(revision 84)
@@ -1,6 +1,9 @@
 package com.framsticks.core;
 
-import com.framsticks.util.*;
-import com.framsticks.util.Thread;
+import com.framsticks.params.FramsClass;
+import com.framsticks.util.dispatching.Thread;
+import com.framsticks.util.dispatching.Dispatcher;
+
+import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
@@ -8,53 +11,93 @@
  * @author Piotr Sniegowski
  */
-public abstract class Entity extends Parameters implements Dispatcher {
+public abstract class Entity implements Dispatcher {
 
-    private final static Logger LOGGER = Logger.getLogger(Entity.class.getName());
+	private final static Logger log = Logger.getLogger(Entity.class.getName());
 
-    public Entity(Parameters parameters) {
-        super(parameters);
-        if (dispatcher == null) {
-            dispatcher = new Thread(name);
-        }
-    }
+	protected String name = "entity";
+	protected EntityOwner owner;
+	protected Dispatcher dispatcher;
 
-    @Override
-    public final boolean isActive() {
-        return dispatcher.isActive();
-    }
+	public Entity() {
+	}
 
-    @Override
-    public final void invokeLater(Runnable runnable) {
-        dispatcher.invokeLater(runnable);
-    }
+	public final String getName() {
+		return name;
+	}
 
-    protected void run() {
-        assert isActive();
-        LOGGER.info("running: " + this);
-    }
+	/**
+	 * @param name the name to set
+	 */
+	public final void setName(String name) {
+		this.name = name;
+		if (dispatcher instanceof Thread) {
+			((Thread) dispatcher).setName(name);
+		}
+	}
 
-    public final void configurePublic() throws Exception {
-        configure();
-    }
+	/**
+	 * @return the owner
+	 */
+	public EntityOwner getOwner() {
+		return owner;
+	}
 
-    protected void configure() throws Exception {
+	/**
+	 * @param owner the owner to set
+	 */
+	public void setOwner(EntityOwner owner) {
+		this.owner = owner;
+	}
 
-    }
+	@Override
+	public final boolean isActive() {
+		return dispatcher == null || dispatcher.isActive();
+	}
 
-    public Dispatcher getDispatcher() {
-        return dispatcher;
-    }
+	@Override
+	public final void invokeLater(Runnable runnable) {
+		assert dispatcher != null;
+		dispatcher.invokeLater(runnable);
+	}
 
-    public final void start() {
-        invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                Entity.this.run();
-            }
-        });
-    }
+	public Dispatcher createDefaultDispatcher() {
+		return new Thread(name);
+	}
+
+	protected void run() {
+		assert isActive();
+		log.info("running: " + this);
+	}
+
+
+	public void configure(Configuration config) {
+	}
+
+	public Dispatcher getDispatcher() {
+		return dispatcher;
+	}
+
+	/**
+	 * @param dispatcher the dispatcher to set
+	 */
+	public void setDispatcher(Dispatcher dispatcher) {
+		this.dispatcher = dispatcher;
+	}
+
+	public final void start() {
+		if (dispatcher == null) {
+			log.debug("no dispatcher set for " + this + ", creating default one");
+			setDispatcher(createDefaultDispatcher());
+		}
+		invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				Entity.this.run();
+			}
+		});
+	}
 
 	public final void done() {
-		LOGGER.info("stopping entity");
+		log.info("stopping entity");
 		if (owner != null) {
 			owner.onDone();
@@ -62,4 +105,6 @@
 	}
 
-
+	public static void constructFramsClass(FramsClass.Constructor constructor) {
+		constructor.method("getName");
+	}
 }
